<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="kz.kgorgulyov.example.server.dao.UserDao">

    <resultMap id="resultUser" type="kz.kgorgulyov.example.share.model.user.User">
        <result property="user" column="userid"/>
        <result property="login" column="login"/>
        <result property="password" column="password"/>
        <result property="salt" column="salt"/>
        <result property="active" column="active"/>
        <result property="name" column="name"/>
        <result property="surname" column="surname"/>
        <result property="role" column="role"/>
        <result property="createdAt" column="created_at"/>

    </resultMap>


    <select id="selByLogin" resultMap="resultUser">
        select us.userid,
               us.login,
               us.password,
               us.salt,
               us.active,
               us.role,
               us.name,
               us.surname,
               us.created_at
        from g_user us

        where us.login = #{login}
          and active
    </select>

    <select id="selById" resultMap="resultUser">
        select us.userid,
               us.login,
               us.password,
               us.salt,
               us.active,
               us.role,
               us.name,
               us.surname,
               us.created_at
        from g_user us

        where us.userid = #{id}
    </select>


    <insert id="mrg">
        insert into g_user (--
            userid,
            login,
            password,
            salt,
            active,
            role,
            name,
            surname,
            created_at)
        values (--
                   #{u.user},
                   #{u.login},
                   #{u.password},
                   #{u.salt},
                   #{u.active},
                   #{u.role},
                   #{u.name},
                   #{u.surname},
                   #{u.createdAt})
        on conflict (userid) do update set role    = excluded.role,
                                           name    = excluded.name,
                                           surname = excluded.surname
        ;
    </insert>

    <update id="updNameAndSurname">
        with to_ins as (select userid, coalesce(#{d.name}, name) as name, coalesce(#{d.surname}, surname) as surname
                        from g_user
                        where userid = #{d.user})
        update g_user
        set name    = s.n,
            surname = s.s
        from (select userid id, name n, surname s from to_ins) s
        where userid = s.id;

    </update>

</mapper>